/*******************Implementation of the Excel coordinates transformation file by Arkgeek***************
*************************Code written by Sebastian Schweizer for www.openvironment.net******************/

#include <math.h>

double polarradius = 6399593.626;
double ei2 = 0.006739497;
double alti;
double lati;
double longi;
double latrad;
double lonrad;
int fuse;
int centmer;
double deltalambda;
double A;
double Xi;
double Eta;
double Ni;
double Zeta;
double An1;  //actually it is A1 but this is reserved for anlalog pin A1
double An2;  //actually it is A2 but this is reserved for anlalog pin A2
double J2;
double J4;
double J6;
double Alfa;
double Beta;
double Gamma;
double Bfi;
double Easting;
double Northing;
String band;
String Hemisphere;
String GPSSentence;

void setup() {
  Serial.begin(115200);
  delay(2000);
  Serial.println("Please enter your coordinates in decimal degrees ...");
  Serial.println("use a CSV format with latitude & longitude. e.g.: 43.773833,11.294507 ");
}

void loop() {
  if (Serial.available() > 0) {
    GPSSentence = Serial.readStringUntil('\r\n');  //read until newline and carriage return
    GPSSentence.trim();
    //}
    if (GPSSentence.length() > 6) {
      int SentenceLength = GPSSentence.length();
      int comma_n_1 = GPSSentence.indexOf(',');

      String LAT = GPSSentence.substring(0, comma_n_1);
      lati = LAT.toFloat();

      if (lati > 0) {
        Hemisphere = "N";
      } else if (lati < 0) {
        Hemisphere = "S";
      }

      String LON = GPSSentence.substring(comma_n_1 + 1, SentenceLength);
      longi = LON.toFloat();

      Serial.print("Latitude is: ");
      Serial.println(lati, 4);
      Serial.print("Longitude is: ");
      Serial.println(longi, 4);

      Calculations();


      Serial.print("UTM Northing (Y) is: ");
      //Serial.println(round(Northing));
      Serial.println(Northing);
      Serial.print("UTM Easting (X) is: ");
      //Serial.println(round(Easting));
      Serial.println(Easting);
      Serial.print("Fuse and band are: ");
      Serial.print(fuse);
      Serial.println(band);
    }
  }
}
